<?php // utf-8 marker: äöü 

if (!function_exists('sv') || preg_match('#plugins/occcal/index.php#i', $_SERVER['SCRIPT_NAME']))
{
	die('no direct access');
}

/*
============================================================
CMSimple Plugin OccCal
============================================================
Version:    OccCal 2.8
Released:   2024-01
Copyright:  Gert Ebersbach
Internet:   www.ge-webdesign.de
============================================================ 
Based on:   OC calendar-Plugin for CMSimple
2009-2012:  Jens Bröcher - cmsimple-styles.com
============================================================ 
License:    Commercial License
see http://www.ge-webdesign.de/cmsimpleplugins/?Nutzungsbedingungen/Commercial_Licence
============================================================ 
*/

define('OCCCAL_VERSION', '2.8');
define('OCCCAL_RELEASE_DATE', '2024-01');

initvar ('txtGruppen');
initvar ('txtTermine');
initvar ('calendarname');
initvar ('occcalsave');

// DEFINE DATA PATH

if(is_writable('./' . $plugin_cf['occcal']['content_path'])) $occcalDataPath = './' . $plugin_cf['occcal']['content_path'];

if(isset($co_author_folder) && is_writable($pth['folder']['base'] . $co_author_folder . $plugin_cf['occcal']['content_path']))
{
	$occcalDataPath = $pth['folder']['base'] . $co_author_folder . $plugin_cf['occcal']['content_path'];
}


if ($occcalsave == "saveit" && $adm) 
{
	if ($fh=fopen($occcalDataPath.$calendarname.'termine.txt', "w")) 
	{
		fwrite($fh,$txtTermine . ';');
		fclose ($fh);
	}
	
	if ($fh=fopen($occcalDataPath.$calendarname.'gruppen.txt', "w")) 
	{
		fwrite($fh, trim($txtGruppen));
		fclose ($fh);
	}
}


function spanit($dtext,$gtext)
{
	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}
	
	return '<span class="occHiddenInline"> + + + </span><span class="occDateList">'.$dtext.': </span> '.$gtext.'<span class="occHiddenBlock"> + + + &nbsp;&nbsp;&nbsp;</span>';
}

function filtereq($ftext)
{
	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}
	
	$x=explode("=", $ftext) ;
	return $x[1];
}

function filtereqNr($ftext)
{
	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}
	
	$x=explode("=", $ftext) ;
	return $x[0];
}

function occcal($calendarname='default',$NumberOfMonth=12,$NumberOfCols=3,$currentMonthPosition=1,$ViewMode='calendar',$allowEdit='edit')
{
	global  $adm,$plugin_cf,$plugin_tx,$cf,$pth,$files,$co_author_folder;


	// define data path

	if(is_writable('./' . $plugin_cf['occcal']['content_path'])) $occcalDataPath = './' . $plugin_cf['occcal']['content_path'];

	if(isset($co_author_folder) && is_writable($pth['folder']['base'] . $co_author_folder . $plugin_cf['occcal']['content_path']))
	{
		$occcalDataPath = $pth['folder']['base'] . $co_author_folder . $plugin_cf['occcal']['content_path'];
	}

	if(isset($co_author_folder) && $co_author_folder != '')$allowEdit = 'noedit';

	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}

	$plugin=basename(dirname(__FILE__),"/");  

	if ($calendarname != '') $calendarname=$calendarname.'_';
	
	if(!isset($co_author_folder) && !file_exists($occcalDataPath.$calendarname.'gruppen.txt') && $adm)
	{
		copy($occcalDataPath . 'default_gruppen.txt',$occcalDataPath.$calendarname.'gruppen.txt');
		chmod($occcalDataPath . $calendarname . 'gruppen.txt', 0666);
	}

	if(!isset($co_author_folder) && !file_exists($occcalDataPath.$calendarname.'termine.txt') && $adm)
	{
		copy($occcalDataPath . 'default_termine.txt',$occcalDataPath.$calendarname.'termine.txt');
		chmod($occcalDataPath . $calendarname . 'termine.txt', 0666);
	}

	$occ_mainWidth = $NumberOfCols*165;
	if($NumberOfCols==0)$occ_mainWidth = 100000;


	$o = "\n" . '<div class="occMain" style="width: 100%; max-width: ' . $occ_mainWidth . 'px">' . "\n"; 


	if ($ViewMode == "Edit" || $ViewMode == "calendar" || ($ViewMode == "list" && $adm && $allowEdit=='edit') || ($ViewMode == "ticker" && $adm && $allowEdit=='edit'))  
	{
		if($adm)
		{
			$o .= "\n" . '<form action="#" name="occcalform1" method="post">' . "\n"; 
			$o .= '<input type="hidden" name="calendarname" value="'.$calendarname.'">' . "\n";
			$o .= '<input type="hidden" name="occcalsave" value="saveit">' . "\n";
			$o .= '<textarea class=occTransferBoxen id="txtGruppen" rows="1" cols="50" name="txtGruppen">' . "\n";
			$o .= rf($occcalDataPath.$calendarname.'gruppen.txt') . "\n";
			$o .= '</textarea>' . "\n";
			$o .= '<textarea class=occTransferBoxen id="txtTermine" rows="1" cols="50" name="txtTermine">' . "\n";
			$o .= rf($occcalDataPath.$calendarname.'termine.txt') . "\n";
			$o .= '</textarea>' . "\n";
			$o .= '</form>' . "\n" . "\n";
		}

		$txtGruppen = rf($occcalDataPath.$calendarname.'gruppen.txt');
		$txtTermine = rf($occcalDataPath.$calendarname.'termine.txt');

		$o .= '<script>
var txtGruppen="' . $txtGruppen . '";
var txtTermine="' . $txtTermine . '";
var NoMonth='.$NumberOfMonth.';
var NoCols='.$NumberOfCols.';
var currentMonthPosition='.$currentMonthPosition.';
var ViewMode="'. $ViewMode.'";
var occChooseStatus="'. $plugin_tx['occcal']['occcal_choose_status'].'";
var occcal_today="'. $plugin_tx['occcal']['occcal_today'].'";
var occcal_nextm="'. $plugin_tx['occcal']['occcal_nextm'].'";
var occcal_nexty="'. $plugin_tx['occcal']['occcal_nexty'].'";
var occcal_prevy="'. $plugin_tx['occcal']['occcal_prevy'].'";
var occcal_prevm="'. $plugin_tx['occcal']['occcal_prevm'].'";
var occcal_save="'. $plugin_tx['occcal']['occcal_save'].'";
var occcal_edit="'. $plugin_tx['occcal']['occcal_edit'].'";
var occcal_1="'. $plugin_tx['occcal']['month_01'].'";
var occcal_2="'. $plugin_tx['occcal']['month_02'].'";
var occcal_3="'. $plugin_tx['occcal']['month_03'].'";
var occcal_4="'. $plugin_tx['occcal']['month_04'].'";
var occcal_5="'. $plugin_tx['occcal']['month_05'].'";
var occcal_6="'. $plugin_tx['occcal']['month_06'].'";
var occcal_7="'. $plugin_tx['occcal']['month_07'].'";
var occcal_8="'. $plugin_tx['occcal']['month_08'].'";
var occcal_9="'. $plugin_tx['occcal']['month_09'].'";
var occcal_10="'. $plugin_tx['occcal']['month_10'].'";
var occcal_11="'. $plugin_tx['occcal']['month_11'].'";
var occcal_12="'. $plugin_tx['occcal']['month_12'].'";
var occcal_mon="' . $plugin_tx['occcal']['day_mon'] . '";
var occcal_tue="' . $plugin_tx['occcal']['day_tue'] . '";
var occcal_wed="' . $plugin_tx['occcal']['day_wed'] . '";
var occcal_thu="' . $plugin_tx['occcal']['day_thu'] . '";
var occcal_fri="' . $plugin_tx['occcal']['day_fri'] . '";
var occcal_sat="' . $plugin_tx['occcal']['day_sat'] . '";
var occcal_sun="' . $plugin_tx['occcal']['day_sun'] . '";
</script>' . "\n";
  
		if($adm && $allowEdit == 'edit')
		{
			$o .= '<script src="'.$pth['folder']['plugins'].$plugin.'/backend.js"></script>' . "\n";
		}
		else
		{
			$o .= '<script src="'.$pth['folder']['plugins'].$plugin.'/frontend.js"></script>' . "\n";
		}
	}
	
	if ($ViewMode == "list" || $ViewMode == "ticker")  $o .= '</div><div style="clear: both;">' . "\n";
	
	if ($ViewMode == "list" || $ViewMode == "ticker")  
	{
		if ($ViewMode == "list")
		{
			$o .= '<ul class="scalCalendarAsText" style="clear: both;">' . "\n";
		}
		
		if ( $ViewMode == "ticker") 
		{
			$o .= '<div class="scalCalendarAsMarquee">' . "\n"; 
			$o .= '<marquee>' . "\n";
		}

		$singlegroups=explode(';',rf($occcalDataPath.$calendarname.'gruppen.txt'));
		$singledates=explode(';',rf($occcalDataPath.$calendarname.'termine.txt'));
		array_pop($singledates);
		$first=true;
		
		foreach ($singledates as $singledateWithGroup)
		{   
			$singledateAndGroup=explode('=',$singledateWithGroup); // format:  2009-11-08=X
			$singledate=$singledateAndGroup[0];
			$singleGroup=$singledateAndGroup[1];
			
			if ($first)
			{
				$lastdate = $singledate;
				$lastGroup=$singleGroup;
				unset($startdate);
				unset($startGroup);
				$first = false;
			}
			else
			{
				// do we have more the one day or the group has been changed ?
				if (strtotime( $singledate) - strtotime( $lastdate)  > 3600*24 ||  $singleGroup != $lastGroup )
				{
					if (isset($startdate)) // do we have a range ? 
					{
						if($ViewMode == 'list')$o .= '<li>';
						$o .= spanIt(date($plugin_tx['occcal']['config_dateformat'], strtotime($startdate)).' - '. date($plugin_tx['occcal']['config_dateformat'],strtotime( $lastdate)) , '<span class="occCalDaySelectedList_' . filtereqNr($singlegroups[$lastGroup-1]) . ' occCalDaySelectedList">' . filtereq( $singlegroups[$lastGroup-1]) . '</span>');
						if($ViewMode == 'list')$o .= '<span class="occ_clearBoth"></span></li>' . "\n";
						unset($startdate);
						unset($startGroup);
					}
					else
					{
						if($ViewMode == 'list')$o .= '<li>';
						$o .= spanIt(date($plugin_tx['occcal']['config_dateformat'],strtotime( $lastdate)), '<span class="occCalDaySelectedList_' . filtereqNr($singlegroups[$lastGroup-1]) . ' occCalDaySelectedList">' . filtereq( $singlegroups[$lastGroup-1]) . '</span>');
						if($ViewMode == 'list')$o .= '<span class="occ_clearBoth"></span></li>' . "\n";
					}
				} 
				else
				{ // Only one day difference, begin building range 
					if (!isset($startdate) ) $startdate = $lastdate;
					if (!isset($startGroup) ) $startGroup = $lastGroup;
				}
				$lastdate = $singledate; 
				$lastGroup= $singleGroup;
			} // end if first
		} // end for  

		if (isset($startdate)) // output of the last date or daterange 
		{
			if($ViewMode == 'list')$o .= '<li>';
			$o .= spanIt(date($plugin_tx['occcal']['config_dateformat'], strtotime($startdate)).' - '. date($plugin_tx['occcal']['config_dateformat'],strtotime( $lastdate)), '<span class="occCalDaySelectedList_' . filtereqNr($singlegroups[$lastGroup-1]) . ' occCalDaySelectedList">' . filtereq( $singlegroups[$lastGroup-1]) . '</span>');
			if($ViewMode == 'list')$o .= '<span class="occ_clearBoth"></span></li>' . "\n";
		}
		else
		{
			if($ViewMode == 'list')$o .= '<li>';
			$o .= spanIt(date($plugin_tx['occcal']['config_dateformat'],strtotime( $lastdate)) ,  '<span class="occCalDaySelectedList_' . filtereqNr($singlegroups[$lastGroup-1]) . ' occCalDaySelectedList">' . filtereq( $singlegroups[$lastGroup-1]) . '</span>');
			if($ViewMode == 'list')$o .= '<span class="occ_clearBoth"></span></li>' . "\n";
		}
		if ($ViewMode == "ticker") 
		{
			$o .= '</marquee>';
		}
		
		if ($ViewMode == "list" )
		{
			$o .= '</ul>';
		}
		else
		{
			$o .= '</div>';
		}
	} 
	$o.= "\n" . '<div style="clear: both;"></div>' . "\n" . '</div>' . "\n";
	
	return  $o;
}

?>